package org.processmining.plugins.DeclareConformance;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.SwingConstants;

import org.processmining.plugins.DataConformance.visualization.DataAwareConformanceView;

import com.fluxicon.slickerbox.components.GradientPanel;

public class AlignRenderer extends GradientPanel implements ListCellRenderer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2972282419460405894L;
	public static final int height = 60;
	public static final int width = 300;
	protected DateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss.SSS");

	protected JLabel nameLabel;
	protected JLabel violationLabel;

	/**
	 * @param colorTop
	 * @param colorBottom
	 */
	public AlignRenderer() {
		super(null,null);
	}
	
	private AlignRenderer(Color colorTop,Color colorBottom)
	{
		super(colorTop,colorBottom);
		//setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setLayout(new BorderLayout());
		setBorder(BorderFactory.createRaisedBevelBorder());
		setMinimumSize(new Dimension(width/2, height));
		setMaximumSize(new Dimension(width*4, height));
		setPreferredSize(new Dimension(width, height));
		nameLabel = new JLabel("name");
		nameLabel.setOpaque(false);
		nameLabel.setFont(nameLabel.getFont().deriveFont(13f));
		nameLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		nameLabel.setHorizontalAlignment(SwingConstants.CENTER);
		nameLabel.setHorizontalTextPosition(SwingConstants.CENTER);
		violationLabel = new JLabel("violation");
		violationLabel.setOpaque(false);
		violationLabel.setFont(violationLabel.getFont().deriveFont(9f));
		violationLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		violationLabel.setHorizontalAlignment(SwingConstants.CENTER);
		violationLabel.setHorizontalTextPosition(SwingConstants.CENTER);
		this.add(nameLabel,BorderLayout.CENTER);
		this.add(violationLabel,BorderLayout.SOUTH);
	}

	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected,
			boolean cellHasFocus) {
		Alignstep step=(Alignstep) value;
		Color fillColor=DataAwareConformanceView.getColor(step.getStepType());
		AlignRenderer retValue=new AlignRenderer(fillColor.brighter().brighter(),fillColor.brighter());
		retValue.nameLabel.setText((index+1)+": "+step.getLabel());
		if(step.getLabel().equals("TICK")){
			retValue.nameLabel.setText((index+1)+": -");
		}
/*		retValue.violationLabel.setText("<html>Contributes to Solve "+step.getContributedToSolve().length+" Violations of Constraints<br>"+
				"Alone Solves "+step.getSolved().length+" Violations of Constraints</html>");*/
		int num=step.getSolved().length+step.getContributedToSolve().length;
		retValue.violationLabel.setText("Contributes to Solve "+num+" Violations of Constraints");
		return retValue;
	}

}
