package org.processmining.plugins.DeclareConformance;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;

import org.processmining.framework.util.ui.widgets.ProMHeaderPanel;
import org.processmining.framework.util.ui.widgets.WidgetColors;
import org.processmining.plugins.DataConformance.Alignment;
import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.visualization.DataAwareStepTypes;
import org.processmining.plugins.declareminer.visualizing.DeclareMap;

import com.fluxicon.slickerbox.ui.SlickerScrollBarUI;


public class AlignmentPanel extends ProMHeaderPanel 
{
	private DefaultListModel listmodel=new DefaultListModel();
	
	public AlignmentPanel(Alignment align, DeclareMap declareModel) {
		super("Details of the Alignment for Trace "+align.getTraceName());
		int index=0;
		Iterator<ExecutionStep> processTraceIter=align.getProcessTrace().iterator();
		Iterator<ExecutionStep> logTraceIter=align.getLogTrace().iterator();
		Iterator<DataAwareStepTypes> stepTypeIter=align.getStepTypes().iterator();
		String label;
		ViolationIdentifier vid=null;
		try {
			vid = new ViolationIdentifier(align.getLogTrace(),align.getProcessTrace(),declareModel);
		} catch (Exception e) {
			e.printStackTrace();
		}
		while(stepTypeIter.hasNext())
		{
			DataAwareStepTypes stepType=stepTypeIter.next();
			ExecutionStep processStep=processTraceIter.next();
			ExecutionStep logStep=logTraceIter.next();
			switch(stepType) {
				case L :
				case LMGOOD :
				case LMNOGOOD :
					label=logStep.getActivity();
					break;
				case MINVI :
				case MREAL :
				default :
					label=processStep.getActivity();
			}
			label=label.replaceAll("<html>", "").replaceAll("</html>", "").replaceAll("<center>", "").
				replaceAll("</center>", "").replaceAll("null", "");
			listmodel.addElement(new Alignstep(label,vid,index++,stepType));
		}
		
		JList list=new JList(listmodel) {
			public String getToolTipText(MouseEvent e) {
		        int index = locationToIndex(e.getPoint());
		        if (-1 < index) {
		        	return ((Alignstep)getModel().getElementAt(index)).getToolTipText();
		        } else {
		          return null;
		        }
		      }			
		};
		list.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		list.setVisibleRowCount(1);
		list.setCellRenderer(new AlignRenderer());
		JScrollPane scroll=new JScrollPane(list);
		JScrollBar vBar = scroll.getVerticalScrollBar();
		vBar.setUI(new SlickerScrollBarUI(vBar, new Color(0, 0, 0, 0), new Color(160, 160, 160),
				WidgetColors.COLOR_NON_FOCUS, 4, 12));
		vBar.setOpaque(true);
		vBar.setBackground(WidgetColors.PROPERTIES_BACKGROUND);
		vBar = scroll.getHorizontalScrollBar();
		vBar.setUI(new SlickerScrollBarUI(vBar, new Color(0, 0, 0, 0), new Color(160, 160, 160),
				WidgetColors.COLOR_NON_FOCUS, 4, 12));
		vBar.setOpaque(true);
		vBar.setBackground(WidgetColors.PROPERTIES_BACKGROUND);		
		scroll.setOpaque(false);
		Dimension size=new Dimension(7000,AlignRenderer.height+23);
		scroll.setMaximumSize(size);
		scroll.setMinimumSize(size);
		Dimension size2=new Dimension(10000,2*(AlignRenderer.height+26));		
		this.setMaximumSize(size2);
		this.setMinimumSize(size2);
		this.setPreferredSize(size2);

		JPanel panel=new JPanel();
		

		final JLabel hLabel = new JLabel(); 
		hLabel.setOpaque(false);
		hLabel.setForeground(WidgetColors.HEADER_COLOR);
		panel.setBorder(BorderFactory.createEmptyBorder());
		panel.setOpaque(false);
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(hLabel);
		panel.add(Box.createHorizontalGlue());
		
		this.add(panel);
		add(Box.createVerticalStrut(15));		
		
		this.add(scroll);
	}
	
}
