package org.processmining.plugins.DeclareConformance;

import org.processmining.plugins.DataConformance.visualization.DataAwareStepTypes;

class Alignstep {
	private final String label;
	private final DataAwareStepTypes stepType;
	private final String[] contributedToSolve;
	private final String[] solved;	
	
	public Alignstep(String label, ViolationIdentifier vid, int index, DataAwareStepTypes stepType) {
		this.label = label;
		if (vid!=null)
			this.contributedToSolve=vid.getViolationsContributedToSolve(index);
		else
			contributedToSolve=new String[0];
		if (vid!=null)
			this.solved=vid.getViolationsSolved(index);
		else
			solved=new String[0];		
		this.stepType = stepType;
	}

	public String getLabel() {
		return label;
	}
	
	public DataAwareStepTypes getStepType() {
		return stepType;
	}
	
	public String toString() {
		return label;
	}

	public String[] getSolved() {
		return solved;
	}

	public String[] getContributedToSolve() {
		return contributedToSolve;
	}

	public String getToolTipText() {
		String[] contributed=getContributedToSolve();
		String[] solved=getSolved();
		if (contributed.length+solved.length==0)
			return "";
		String[] contributed2=new String[contributed.length+solved.length];
		int j=0;
		for(String x : contributed)
			contributed2[j++]=x;
		for(String x : solved)
			contributed2[j++]=x;		
		StringBuffer sb=new StringBuffer("<html><table border=\"1\">");
		if (contributed2.length>0)
		{
			sb.append("<tr><td rowspan=\"");
			sb.append(contributed2.length);
			sb.append("\"><b>Contributes to Solve:</b></td><td>"+contributed2[0]+"</td></tr>");
			for(int i=1;i<contributed2.length;i++)
			{
				sb.append("<tr><td style=\"border: none\">");
				sb.append(contributed2[i]);
				sb.append("</td></tr>");
			}
		}
		/*if (solved.length>0)
		{
			sb.append("<tr><td rowspan=\"");
			sb.append(solved.length);
			sb.append("\"><b>Alone Solves:</b></td><td>"+solved[0]+"</td></tr>");
			for(int i=1;i<solved.length;i++)
			{
				sb.append("<tr><td style=\"border: none\">");
				sb.append(solved[i]);
				sb.append("</td></tr>");
			}
		}*/
		return sb.toString();
	}
	
}
