package org.processmining.plugins.DeclareConformance;

import java.util.Collection;
import java.util.Map;
import java.util.Vector;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.DataConformance.framework.ActivityMatchCosts;
import org.processmining.plugins.DataConformance.framework.DataReplayer;
import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.framework.ReplayState;
import org.processmining.plugins.DataConformance.framework.Replayable;
import org.processmining.plugins.DataConformance.framework.ReplayableActivity;
import org.processmining.plugins.DataConformance.framework.ReplayingHelper;
import org.processmining.plugins.DataConformance.framework.VariableMatchCosts;

class DeclareReplayer extends DataReplayer
{
	public DeclareReplayer(Replayable model, Map<ReplayableActivity, XEventClass> activityMapping,
			Map<String, String> variableMapping, XEventClasses eventClasses, XTrace trace,
			ActivityMatchCosts activityCost, VariableMatchCosts variableCost, Map<String, Float> maxDistance,
			Collection<ReplayState> list, UIPluginContext context, boolean prune) {
		super(model, activityMapping, variableMapping, eventClasses, trace, activityCost, variableCost, maxDistance, list,
				context, prune);
		helper=new ReplayingHelper(model,trace,activityMapping,variableMapping,eventClasses, 
				maxDistance, activityCost, variableCost)
		{
			@Override
			protected ExecutionStep getExecutionStep(XEvent event)
			{
				ExecutionStep retValue=super.getExecutionStep(event);
				if (retValue==null)
					retValue=DeclareExecutionTrace.tickStep;
				return retValue;
				
			}
		};
	}
	
}

public class MultiThreadDeclareConformanceChecking {
	@SuppressWarnings("unchecked")
	public static Collection<ReplayState> perform(Replayable model, Map activityMapping,
			Map<String, String> variableMapping, XEventClasses eventClasses, XLog log,
			ActivityMatchCosts activityCost, VariableMatchCosts variableCost, 
			Map<String, Float> maxDistance, UIPluginContext context, boolean subOptimalHeur) throws InterruptedException
	{
		Collection<ReplayState> list=new Vector<ReplayState>();
		for (XTrace trace : log)
		{
			DeclareReplayer replayer=new DeclareReplayer(model, activityMapping, variableMapping, 
					eventClasses,trace, activityCost, variableCost, maxDistance, list, context, subOptimalHeur);
			replayer.run();
		}
		return list;
	}
}
