package org.processmining.plugins.DeclareConformance;

import java.util.ListIterator;
import java.util.Set;
import java.util.Vector;

import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.framework.ExecutionTrace;
import org.processmining.plugins.DataConformance.framework.LogExecutionTrace;
import org.processmining.plugins.DataConformance.framework.Replayable;
import org.processmining.plugins.declareminer.visualizing.ActivityDefinition;
import org.processmining.plugins.declareminer.visualizing.DeclareMap;


public class ReplayableDeclare implements Replayable {
	private DeclareMap model;

	public ReplayableDeclare(DeclareMap model) {
		this.model=model;
	}

	public ExecutionTrace buildEmptyPrefix() {
		return new DeclareExecutionTrace(model);
	}

	public String getSetForVariable(String var) {
		return null;
	}

	public Set<Comparable> getSetValues(String setForVariable) {
		return null;
	}

	public int lengthShortestTrace() {
		return 0;
	}

	public ExecutionTrace createLogExecutionTrace(ExecutionTrace sigmaT) {
		Vector activities = new Vector();
		for(ActivityDefinition ad: model.getModel().getActivityDefinitions()){
			activities.add(ad.getName());
		}
		
		ListIterator<ExecutionStep> liter=sigmaT.listIterator();
		while(liter.hasNext())
		{
			ExecutionStep next=liter.next();
			if (!activities.contains(next.getActivity()))
			{
				liter.remove();
				liter.add(DeclareExecutionTrace.tickStep);
			}
		}
		return new LogExecutionTrace(sigmaT);
	}
}
