package org.processmining.plugins.DeclareDataAwareComplianceChecker.models;

import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.State;
/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.Transition;

public class DataAltPrecedenceConst extends DataDeclareConstraint {
	
	public DataAltPrecedenceConst (String activation, String target, Expression exp){
		super(activation, target, exp);
		int id = 1;
		State state2 = new State(id);
		id++;
		this.addState(state2);
		this.getInit().setAccepting(true);
		state2.setAccepting(true);

		//All is allowed except A and B{true}
		Transition t1 = new Transition(this.getInit(), this.getInit(), rest);
		Transition t2 = new Transition(this.getInit(), this.getInit(), activation + "false");
		
		//A goes to next state
		Transition t3 = new Transition(this.getInit(), state2, target);
		
		//Everything is allowed in this state except B
		Transition t4 = new Transition(state2, state2, rest);
		Transition t5 = new Transition(state2, state2, target);
		
		//Do a B to get back to initial state
		Transition t42 = new Transition(state2, this.getInit(), activation + "false");
		Transition t43 = new Transition(state2, this.getInit(), activation + "true");
		
		super.createExecAutomaton(this);
		
	}

}
