package org.processmining.plugins.DeclareDataAwareComplianceChecker.models;

import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.State;
/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.Transition;

public class DataRespondedExistenceConst extends DataDeclareConstraint{

	public DataRespondedExistenceConst (String activation, String target, Expression exp){
		super(activation, target, exp);
		int id = 1;
		State state2 = new State(id);
		id++;
		State state3 = new State(id);
		id++;
		State state4 = new State(id);
		id++;
		
		this.getInit().setAccepting(true);
		state2.setAccepting(true);
		state4.setAccepting(true);
		
		this.addState(state2);
		this.addState(state3);
		this.addState(state4);
		
		//All except A{true} and B
		Transition t1 = new Transition(this.getInit(), this.getInit(), rest);
		Transition t2 = new Transition(this.getInit(), this.getInit(), activation + "false");
		
		//B goes to the next final state
		Transition t12 = new Transition(this.getInit(), state2, target);
		
		//A{true} goes to the next non final state
		Transition t3 = new Transition(this.getInit(), state3, activation + "true");
		
		//All is allowed in this state
		Transition t4 = new Transition(state2, state2, rest);
		Transition t41 = new Transition(state2, state2, target);
		Transition t42 = new Transition(state2, state2, activation + "false");
		Transition t43 = new Transition(state2, state2, activation + "true");
		
		//All is allowed in this state except B
		Transition t5 = new Transition(state3, state3, rest);
		Transition t52 = new Transition(state3, state3, activation + "false");
		Transition t53 = new Transition(state3, state3, activation + "true");
		
		
		// B goes to final state
		Transition t6 = new Transition(state3, state4, target);
		
		//All is allowed in this state
		Transition t7 = new Transition(state4, state4, rest);
		Transition t71 = new Transition(state4, state4, target);
		Transition t72 = new Transition(state4, state4, activation + "false");
		Transition t73 = new Transition(state4, state4, activation + "true");
		
		super.createExecAutomaton(this);
	}
}

