package org.processmining.plugins.DeclareDataAwareComplianceChecker.models;

import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.State;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.Transition;

/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class NotDataChainPrecedenceConst extends DataDeclareConstraint {
	
	public NotDataChainPrecedenceConst (String activation, String target, Expression exp){
		super(activation, target, exp);
		int id = 1;
		State state2 = new State(id);
		id++;
		this.addState(state2);
		this.getInit().setAccepting(true);
		state2.setAccepting(true);

		//All is allowed except A 
		Transition t1 = new Transition(this.getInit(), this.getInit(), rest);
		Transition t2 = new Transition(this.getInit(), this.getInit(), activation + "false");
		Transition t21 = new Transition(this.getInit(), this.getInit(), activation + "true");
		
		//A goes to next state
		Transition t3 = new Transition(this.getInit(), state2, target);
		
		//Only A is allowed in this state
		Transition t5 = new Transition(state2, state2, target);
		
		// Every task except for A or B{true} results in going back to initial state
		Transition t4 = new Transition(state2, this.getInit(), rest);
		Transition t42 = new Transition(state2, this.getInit(), activation + "false");		
		
		super.createExecAutomaton(this);
		
	}

}
