package org.processmining.plugins.DeclareDataAwareComplianceChecker.models;

import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.State;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.Transition;

/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class NotDataChainResponseConst extends DataDeclareConstraint{

	public NotDataChainResponseConst (String activation, String target, Expression exp){
		super(activation, target, exp);
		int id = 1;
		State state2 = new State(id);
		id++;
		
		state2.setAccepting(true);
		this.getInit().setAccepting(true);
	
		this.addState(state2);

		//All except A{true}
		Transition t1 = new Transition(this.getInit(), this.getInit(), rest);
		Transition t12 = new Transition(this.getInit(), this.getInit(), target);
		Transition t2 = new Transition(this.getInit(), this.getInit(), activation + "false");
		
		//A{true} goes to the next final state
		Transition t3 = new Transition(this.getInit(), state2, activation + "true");
		
		// all except B goes back to initial state
		Transition t4 = new Transition(state2, this.getInit(), rest);
		Transition t5 = new Transition(state2, this.getInit(), activation + "false");
		Transition t6 = new Transition(state2, this.getInit(), activation + "true");
		
		super.createExecAutomaton(this);
	}
}
