package org.processmining.plugins.DeclareDataAwareComplianceChecker.models;

import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.State;
import org.processmining.plugins.DeclareDataAwareComplianceChecker.automata.Transition;

/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class NotDataRespondedExistenceConst extends DataDeclareConstraint{

	public NotDataRespondedExistenceConst (String activation, String target, Expression exp){
		super(activation, target, exp);
		int id = 1;
		State state2 = new State(id);
		id++;
		State state3 = new State(id);
		id++;

		
		this.getInit().setAccepting(true);
		state2.setAccepting(true);
		state3.setAccepting(true);
		
		this.addState(state2);
		this.addState(state3);
		
		//All except A{true} and B
		Transition t1 = new Transition(this.getInit(), this.getInit(), rest);
		Transition t2 = new Transition(this.getInit(), this.getInit(), activation + "false");
		
		//B goes to the next final state
		Transition t12 = new Transition(this.getInit(), state2, target);
		
		//A{true} goes to the next non final state
		Transition t3 = new Transition(this.getInit(), state3, activation + "true");
		
		//All is allowed in this state except A{true}
		Transition t4 = new Transition(state2, state2, rest);
		Transition t41 = new Transition(state2, state2, target);
		Transition t42 = new Transition(state2, state2, activation + "false");

		
		//All is allowed in this state except B
		Transition t5 = new Transition(state3, state3, rest);
		Transition t52 = new Transition(state3, state3, activation + "false");
		Transition t53 = new Transition(state3, state3, activation + "true");
		
		
		super.createExecAutomaton(this);
	}
}

