package org.processmining.plugins.DeclareMapWithData.dialogs;

import java.text.ParseException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.NoSuchElementException;

import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;

import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.DataElement;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;
import org.processmining.models.guards.Expression;

/*
 * Original code: M. de Leoni
 * Modified by: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class AddGuardCellEditor extends DefaultCellEditor  {
	private AddOperationsAndGuardsPanel frame;
	private JTable table;
	private Collection<DataElement> allDataElements;
	private HashSet<String> allDataTypes;
	
	
	public AddGuardCellEditor(JTable table2, HashSet<String> datatypes,
			AddOperationsAndGuardsPanel addOperationsAndGuardsPanel) {
		super(new JTextField());
		this.table=table2;
		this.frame=addOperationsAndGuardsPanel;
		this.allDataTypes=datatypes;
	}

	@Override
	public Object getCellEditorValue() {
		try {
			if (!((String)super.getCellEditorValue()).trim().isEmpty())
			{
				Expression expr=new Expression((String) super.getCellEditorValue());
				Enumeration variableEnumeration=expr.findVariables();
				while(variableEnumeration.hasMoreElements())
				{
					String variableInExpression=((String) variableEnumeration.nextElement());
					if(!containVariable(variableInExpression))
					{
						frame.setMessage("Variable "+variableInExpression+" was not specified");
						throw new IllegalArgumentException("Variable "+variableInExpression+" was not specified");
					}
				}
				frame.setMessage("Correctly parsed as "+expr+".");
			}
			else
				frame.setMessage("Correctly parsed as no guard");
			return super.getCellEditorValue();
		} 
		catch (NoSuchElementException e) {
			frame.setMessage("Expression "+super.getCellEditorValue()+" is not parseable: Unexpected null token");
			throw new IllegalArgumentException(e);
		}			
		catch (ParseException e) {
			frame.setMessage("Expression "+super.getCellEditorValue()+" is not parseable: "+e.getMessage());
			throw new IllegalArgumentException(e);
		}
    }

	@SuppressWarnings("unchecked")
	private boolean containVariable(String variable) {
		HashSet<String> dataElements;
		if (variable.contains(PetriNetWithData.WRITE_CHAR+""))
		{
			variable=variable.replace(PetriNetWithData.WRITE_CHAR, ' ');
			int row=table.getSelectedRow();
			dataElements=(HashSet<String>)table.getModel().getValueAt(row, 2);
		}
		else
			dataElements=allDataTypes;
		variable=variable.trim();
		if (dataElements!= null)
		{
			for(String elem : dataElements)
				if (elem.equals(variable))
					return true;
		}
		return false;
	}

}
