package org.processmining.plugins.DeclareMapWithData.dialogs;

import java.awt.BorderLayout;
import java.text.ParseException;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import org.processmining.framework.util.ui.widgets.ProMHeaderPanel;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.DataElement;
import org.processmining.models.guards.Expression;
import org.processmining.plugins.DeclareMapWithData.models.DataDeclareMap;

/*
 * Original code: M. de Leoni
 * Modified by: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class AddOperationsAndGuardsPanel extends ProMHeaderPanel {
		private Object columnNames[] = { "Relation",  "Guard"};
		private DefaultTableModel dtm;
		private JTable table;
		private Object data[][];
		private JTextField errorMessageLbl;
		
		public void setMessage(String text)
		{
			errorMessageLbl.setText(text);
		}
		
		public AddOperationsAndGuardsPanel(String[] relations, HashSet<String> datatypes) { //, 
			super("Add Guards");
			data=new Object[relations.length][2]; // 4?
			
			dtm=new DefaultTableModel(data,columnNames) {
				public boolean isCellEditable(int row, int column)
				{
					return(column>0);
				}
			};
			for(int i = 0; i < relations.length; i++){
				dtm.setValueAt(relations[i], i, 0);
			}
			table=new JTable(dtm);
			table.getColumnModel().getColumn(1).setCellEditor(new AddGuardCellEditor(table,datatypes,this));  
			this.setLayout(new BorderLayout());
			this.add(new JScrollPane(table),BorderLayout.CENTER);
			errorMessageLbl=new JTextField();
			errorMessageLbl.setEditable(false);
			this.add(errorMessageLbl,BorderLayout.SOUTH);
		}
		
		public AddOperationsAndGuardsPanel(String[] relations, HashSet<String> datatypes, DataDeclareMap map) { //, 
			super("Add Guards");
			String[] importedGuards = map.getGuards();
			data=new Object[relations.length][2]; // 4?
			
			dtm=new DefaultTableModel(data,columnNames) {
				public boolean isCellEditable(int row, int column)
				{
					return(column>0);
				}
			};
			for(int i = 0; i < relations.length; i++){
				dtm.setValueAt(relations[i], i, 0);
				dtm.setValueAt(importedGuards[i], i, 1);
			}
			/*
			for(int i = 0; i < importedGuards.length; i++){
				dtm.setValueAt(importedGuards[i], i, 1);
			}
			*/
			table=new JTable(dtm);
			table.getColumnModel().getColumn(1).setCellEditor(new AddGuardCellEditor(table,datatypes,this));  
			this.setLayout(new BorderLayout());
			this.add(new JScrollPane(table),BorderLayout.CENTER);
			errorMessageLbl=new JTextField();
			errorMessageLbl.setEditable(false);
			this.add(errorMessageLbl,BorderLayout.SOUTH);
		}
		
		private Collection<DataElement> retrieveFromCollection(Set<DataElement> readOperations, Collection<DataElement> dataElements) {
			Collection<DataElement> retValue=new HashSet<DataElement>();
			for(DataElement elemToSearch : readOperations)
				for(DataElement elemToAdd : dataElements)
					if (elemToSearch.equals(elemToAdd))
					{
						retValue.add(elemToAdd);
						break;
					}
			if (retValue.size()==0)
				return null;
			else
				return retValue;
		}
		
		public String getGuard() {
			return "";
		}
		
		public String[] getGuardsStrings() {
			String[] output = new String[dtm.getRowCount()];
			for(int i=0;i<dtm.getRowCount();i++)
			{
				if(dtm.getValueAt(i, 1) != null){
					output[i] = (String)dtm.getValueAt(i, 1);
				}
				else output[i] = "";
			}
			return output;
		}
		
		public Expression[] getGuards() throws ParseException {
			Expression[] output = new Expression[dtm.getRowCount()];
			for(int i=0;i<dtm.getRowCount();i++)
			{	
				//(String)super.getCellEditorValue()).trim().isEmpty() 				&& !elem.getGuard().isEmpty()
				//System.out.println((String)dtm.getValueAt(i, 1) + " in de if");
				if((dtm.getValueAt(i, 1) != null) && !((String)dtm.getValueAt(i, 1)).isEmpty() ) { 
					output[i] = new Expression( (String)dtm.getValueAt(i, 1) );	
				}
				else { 
					output[i] = null;
				}
			}
			return output;
		}
		

	}

