package org.processmining.plugins.DeclareMapWithData.dialogs;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import org.processmining.framework.util.ui.widgets.ProMHeaderPanel;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.DataElement;
import org.processmining.plugins.DeclareMapWithData.models.DataDeclareMap;

import com.fluxicon.slickerbox.components.SlickerButton;

/*
 * Original code: M. de Leoni
 * Modified by: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

class CellValueVerification extends DefaultCellEditor
{
	private JTable table;
	private JTextField field=new JTextField();

	public CellValueVerification(JTable table)
	{
		this(table,new JTextField());
	}
	
	private CellValueVerification(JTable table,JTextField aField) {
		super(aField);
		field=aField;
		this.table=table;
	}
	
	@Override
	public Object getCellEditorValue() {
		String value=field.getText();
		Class<?> type=(Class<?>)table.getModel().getValueAt(table.getEditingRow(), 1);
		Object convValue=null;
		try {
			convValue=type.getConstructor(String.class).newInstance(value);
		} 
		catch (Exception err) {	}
		convValue.toString();
        return value;
    }
	
}

public class AddVariablesPanel extends ProMHeaderPanel
{
	private static final long serialVersionUID = 1L;
	private Object columnNames[] = { "Variable Name"};
	//private Object columnNames[] = { "Variable Name", "Type", "Minimum Value", "Maximum Value"};
	private DefaultTableModel dtm=new DefaultTableModel(columnNames, 0);
	private SlickerButton addButton=new SlickerButton("Add Variable");
	private SlickerButton removeButton=new SlickerButton("Remove Variable");	
	private JTable table=new JTable(dtm);
	
	HashSet<DataElement> retValue = null;
	
	HashSet<String> retValue2 = null;
	
	public AddVariablesPanel() {
		super("Add Process Variables");
		init();
	}
	
	private void init()
	{		
		JComboBox combo = new JComboBox();
		combo.addItem(String.class);
		combo.addItem(Long.class);
		combo.addItem(Double.class);
		combo.addItem(Date.class);
		combo.addItem(Boolean.class);
		//table.getColumnModel().getColumn(3).setCellEditor(new CellValueVerification(table));
		//table.getColumnModel().getColumn(2).setCellEditor(new CellValueVerification(table));
		//table.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(combo));
		
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(table), BorderLayout.CENTER);
		JPanel south=new JPanel(new FlowLayout(FlowLayout.CENTER));
		south.add(addButton);
		south.add(removeButton);
		this.add(south,BorderLayout.SOUTH);
		
		addButton.addActionListener(new ActionListener() {		
			public void actionPerformed(ActionEvent arg0) {
				dtm.addRow((Object[])null);
			}
		});
		
		removeButton.addActionListener(new ActionListener() {	
			public void actionPerformed(ActionEvent arg0) {
				int indexes[]=table.getSelectedRows();
				for(int i=indexes.length-1;i>=0;i--)
					dtm.removeRow(indexes[i]);
			}
		});
	}
	
	public AddVariablesPanel(DataDeclareMap ddmap) {
		super("Add Process Variables");
		init();
		String[] variables = new String[ddmap.getVariables().size()];
		variables = ddmap.getVariables().toArray( variables ); //new String[0]
		System.out.println(variables.length);
		
		System.out.println(ddmap.getVariables().size());
//		Arrays.sort(variables, new Comparator<DataElement>() {
//
//			public int compare(DataElement o1, DataElement o2) {
//				return o1.getVarName().compareTo(o2.getVarName());
//			}
//		});
		
		for(String elem : variables)
		{
			Object row[]=new Object[4];
			row[0]=elem;
//			row[1]=elem.getType();
//			Comparable value=elem.getMinValue();
//			if (value!=null)
//				row[2]=value.toString();
//			else
//				row[2]="";
//			value=elem.getMaxValue();
//			if (value!=null)
//				row[3]=value.toString();
//			else
//				row[3]="";
//			row[1]=null;
//			row[2]=null;
//			row[3]=null;
			dtm.addRow(row);
		}
		init();
	}

//	@SuppressWarnings("unchecked")
//	public Set<DataElement> getDataElements()
//	{
//		if (retValue!=null)
//			return retValue;
//		int index=dtm.getRowCount()-1;
//		
//		retValue=new HashSet<DataElement>();
//		for(;index>=0;index--)
//		{
//			DataElement element;
//			String varName=(String) dtm.getValueAt(index, 0);
//			Class varType=(Class) dtm.getValueAt(index, 1);
//			String minValueString=(String)dtm.getValueAt(index, 2);
//			if (minValueString!=null && minValueString.equals(""))
//				minValueString=null;
//			String maxValueString=(String)dtm.getValueAt(index, 3);
//			if (maxValueString!=null && maxValueString.equals(""))
//				maxValueString=null;
//			Constructor constr=null;
//			try {
//				constr=varType.getConstructor(String.class);
//				Comparable<Object> minValue=null;
//				if (minValueString!=null)
//					minValue=(Comparable<Object>)constr.newInstance(minValueString);
//				Comparable<Object> maxValue=null;
//				if (maxValueString!=null)
//					maxValue=(Comparable<Object>)constr.newInstance(maxValueString);
//				element=new DataElement(varName, varType, minValue, maxValue,null);
//				retValue.add(element);
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//			
//		}
//		return retValue;
//		
//	}
	
	@SuppressWarnings("unchecked")
	public Set<String> getDataElements2()
	{
		if (retValue2!=null)
			return retValue2;
		int index=dtm.getRowCount()-1;
		retValue2=new HashSet<String>();
		
		for(;index>=0;index--)
		{
			if(dtm.getValueAt(index, 0) != null){
				String element=(String) dtm.getValueAt(index, 0);
				retValue2.add(element);
			}

	/*		
			String varName=(String) dtm.getValueAt(index, 0);
			Class varType=(Class) dtm.getValueAt(index, 1);
			String minValueString=(String)dtm.getValueAt(index, 2);
			if (minValueString!=null && minValueString.equals(""))
				minValueString=null;
			String maxValueString=(String)dtm.getValueAt(index, 3);
			if (maxValueString!=null && maxValueString.equals(""))
				maxValueString=null;
			Constructor constr=null;
			try {
				constr=varType.getConstructor(String.class);
				Comparable<Object> minValue=null;
				if (minValueString!=null)
					minValue=(Comparable<Object>)constr.newInstance(minValueString);
				Comparable<Object> maxValue=null;
				if (maxValueString!=null)
					maxValue=(Comparable<Object>)constr.newInstance(maxValueString);
				element=new DataElement(varName, varType, minValue, maxValue,null);
				retValue2.add(element);
			} catch (Exception e) {
				e.printStackTrace();
			}
			*/
		}
		return retValue2;
		
	}
}