package org.processmining.plugins.DeclareMapWithData.models;
import java.util.HashSet;

import org.processmining.plugins.declareminer.visualizing.AssignmentModel;
import org.processmining.plugins.declareminer.visualizing.AssignmentModelView;
import org.processmining.plugins.declareminer.visualizing.AssignmentViewBroker;
import org.processmining.plugins.declareminer.visualizing.ConstraintDefinition;


/*
 * Author: M.H.M. Schouten
 * E-mail: m.h.m.schouten0@gmail.com
 * 
 */

public class DataDeclareMap {

	private final transient AssignmentModel model;
	private final transient AssignmentModelView view;
	private final transient AssignmentViewBroker broker;
	
	private final transient org.processmining.plugins.declare.visualizing.AssignmentModel modelCh;
	private final transient org.processmining.plugins.declare.visualizing.AssignmentModelView viewCh;
	private final transient org.processmining.plugins.declare.visualizing.AssignmentViewBroker brokerCh;
	
	public HashSet<String> dataTypes = new HashSet<String>();
	
	ConstraintDefinition[] CDarray;
	String[] CDNamearray;
	String[] guards;
	

	/**
	 * @param model
	 * @param view
	 */
	public DataDeclareMap(final AssignmentModel model,  final AssignmentModelView view, final AssignmentViewBroker broker, final org.processmining.plugins.declare.visualizing.AssignmentModel modelCh,  final org.processmining.plugins.declare.visualizing.AssignmentModelView viewCh, final org.processmining.plugins.declare.visualizing.AssignmentViewBroker brokerCh) {
		this.model = model;
		this.view = view;
		this.broker = broker;
		this.modelCh = modelCh;
		this.viewCh = viewCh;
		this.brokerCh = brokerCh;
	}

	/**
	 * @return
	 */
	public AssignmentModel getModel() {
		return model;
	}

	public AssignmentViewBroker getBroker() {
		return broker;
	}

	/**
	 * @return
	 */
	public AssignmentModelView getView() {
		return view;
	}
	
	public HashSet<String> getVariables() {
		return dataTypes;
	}
	
	public void setVariables(HashSet<String> s) {
		dataTypes = s;	
	}
	
	public void addVariable(String s) {
		dataTypes.add(s);
	}
	
	public boolean hasVariable(String s) {
		return (dataTypes.contains(s));
	}
	

	public org.processmining.plugins.declare.visualizing.AssignmentModel getModelCh() {
		return modelCh;
	}

	public org.processmining.plugins.declare.visualizing.AssignmentViewBroker getBrokerCh() {
		return brokerCh;
	}

	/**
	 * @return
	 */
	public org.processmining.plugins.declare.visualizing.AssignmentModelView getViewCh() {
		return viewCh;
	}
	
	public ConstraintDefinition[] getCDarray() {
		return CDarray;
	}

	public String[] getCDNamearray() {
		return CDNamearray;
	}

	public String[] getGuards() {
		return guards;
	}
	
	public void setCDarray(ConstraintDefinition[] a) {
		CDarray = a;
	}

	public void setCDNamearray(String[] a) {
		CDNamearray = a;
	}

	public void setGuards(String[] a) {
		guards = a;
	}
}
